org.sonatype.plexus.build.incremental

## Class DefaultBuildContext

- java.lang.Object
- - org.codehaus.plexus.logging.AbstractLogEnabled
  - - org.sonatype.plexus.build.incremental.DefaultBuildContext

All Implemented Interfaces:
  org.codehaus.plexus.logging.LogEnabled, BuildContext

    public class DefaultBuildContext
    extends org.codehaus.plexus.logging.AbstractLogEnabled
    implements BuildContext

Filesystem based non-incremental build context implementation which behaves as if all files were just created. More specifically, hasDelta returns `true` for all paths newScanner returns Scanner that scans all files under provided basedir newDeletedScanner always returns empty scanner. isIncremental returns `false</code< getValue always returns <code>null`

### Field Summary

### Fields inherited from interface org.sonatype.plexus.build.incremental.BuildContext

`SEVERITY_ERROR, SEVERITY_WARNING`

### Constructor Summary

Constructors
Constructor and Description
`DefaultBuildContext()`

### Method Summary

Methods
`void` `addError(File file, int line, int column, String message, Throwable cause)` Deprecated. Use addMessage with severity=SEVERITY_ERROR instead
`void` `addMessage(File file, int line, int column, String message, int severity, Throwable cause)` Adds a message to the build context.
`void` `addWarning(File file, int line, int column, String message, Throwable cause)` Deprecated. Use addMessage with severity=SEVERITY_WARNING instead
`Object` `getValue(String key)` Returns value associated with `key` during previous mojo execution.
`boolean` `hasDelta(File file)` Returns `true` if the file has changed since last build or is not under basedir.
`boolean` `hasDelta(List relpaths)` Returns `true` if any file or folder identified by `relpaths` has changed since last build.
`boolean` `hasDelta(String relpath)` Returns `true` if file or folder identified by `relpath` has changed since last build.
`boolean` `isIncremental()` Returns `true` if this build context is incremental.
`boolean` `isUptodate(File target, File source)` Returns true, if the target file exists and is uptodate compared to the source file.
`org.codehaus.plexus.util.Scanner` `newDeleteScanner(File basedir)` Returned Scanner scans `basedir` for files and directories deleted since last build.
`OutputStream` `newFileOutputStream(File file)` Returns new OutputStream that writes to the `file`.
`org.codehaus.plexus.util.Scanner` `newScanner(File basedir)` Convenience method, fully equal to newScanner(basedir, false)
`org.codehaus.plexus.util.Scanner` `newScanner(File basedir, boolean ignoreDelta)` Returned Scanner scans files and folders under `basedir`.
`void` `refresh(File file)` Indicates that the file or folder content has been modified during the build.
`void` `removeMessages(File file)` Removes all messages associated with a file or folder during a previous build.
`void` `setValue(String key, Object value)` Associate specified `key` with specified `value` in the build context.

### Methods inherited from class org.codehaus.plexus.logging.AbstractLogEnabled

`enableLogging, getLogger, setupLogger, setupLogger, setupLogger`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### DefaultBuildContext

    public DefaultBuildContext()

### Method Detail

#### hasDelta

    public boolean hasDelta(String relpath)

Description copied from interface: `BuildContext`
Returns `true` if file or folder identified by `relpath` has changed since last build.

Specified by:
  `hasDelta` in interface `BuildContext`
Parameters:
  `relpath` - is path relative to build context basedir

#### hasDelta

    public boolean hasDelta(File file)

Description copied from interface: `BuildContext`
Returns `true` if the file has changed since last build or is not under basedir.

Specified by:
  `hasDelta` in interface `BuildContext`

#### hasDelta

    public boolean hasDelta(List relpaths)

Description copied from interface: `BuildContext`
Returns `true` if any file or folder identified by `relpaths` has changed since last build.

Specified by:
  `hasDelta` in interface `BuildContext`
Parameters:
  `relpaths` - List<String> are paths relative to build context basedir

#### newFileOutputStream

    public OutputStream newFileOutputStream(File file)
                                     throws IOException

Description copied from interface: `BuildContext`
Returns new OutputStream that writes to the `file`. Files changed using OutputStream returned by this method do not need to be explicitly refreshed using `BuildContext.refresh(File)`. As an optional optimisation, OutputStreams created by incremental build context will attempt to avoid writing to the file if file content has not changed.

Specified by:
  `newFileOutputStream` in interface `BuildContext`
Throws:
  `IOException`

#### newScanner

    public org.codehaus.plexus.util.Scanner newScanner(File basedir)

Description copied from interface: `BuildContext`
Convenience method, fully equal to newScanner(basedir, false)

Specified by:
  `newScanner` in interface `BuildContext`

#### refresh

    public void refresh(File file)

Description copied from interface: `BuildContext`
Indicates that the file or folder content has been modified during the build.

Specified by:
  `refresh` in interface `BuildContext`
See Also:
  `BuildContext.newFileOutputStream(File)`

#### newDeleteScanner

    public org.codehaus.plexus.util.Scanner newDeleteScanner(File basedir)

Description copied from interface: `BuildContext`
Returned Scanner scans `basedir` for files and directories deleted since last build. Returns empty Scanner if `basedir` is not under this build context basedir.

Specified by:
  `newDeleteScanner` in interface `BuildContext`

#### newScanner

    public org.codehaus.plexus.util.Scanner newScanner(File basedir,
                                              boolean ignoreDelta)

Description copied from interface: `BuildContext`
Returned Scanner scans files and folders under `basedir`. If this is an incremental build context and `ignoreDelta` is `false`, the scanner will only "see" files and folders with content changes since last build. If `ignoreDelta` is `true`, the scanner will "see" all files and folders. Please beware that ignoreDelta=false does NOT work reliably for operations that copy resources from source to target locations. Returned Scanner only scans changed source resources and it does not consider changed or deleted target resources. This results in missing or stale target resources. Starting with 0.5.0, recommended way to process resources is to use #newScanner(basedir,true) to locate all source resources and `BuildContext.isUptodate(File, File)` to optimized processing of uptodate target resources. Returns empty Scanner if `basedir` is not under this build context basedir.

Specified by:
  `newScanner` in interface `BuildContext`
See Also:
  `http://jira.codehaus.org/browse/MSHARED-125`

#### isIncremental

    public boolean isIncremental()

Description copied from interface: `BuildContext`
Returns `true` if this build context is incremental. Scanners created by `BuildContext.newScanner(File)` of an incremental build context will ignore files and folders that were not changed since last build. Additionally, `BuildContext.newDeleteScanner(File)` will scan files and directories deleted since last build.

Specified by:
  `isIncremental` in interface `BuildContext`

#### getValue

    public Object getValue(String key)

Description copied from interface: `BuildContext`
Returns value associated with `key` during previous mojo execution. This method always returns `null` for non-incremental builds (i.e., `BuildContext.isIncremental()` returns `false`) and mojos are expected to fall back to full, non-incremental behaviour.

Specified by:
  `getValue` in interface `BuildContext`
See Also:
  `BuildContext.setValue(String, Object)`, `BuildContext.isIncremental()`

#### setValue

    public void setValue(String key,
                Object value)

Description copied from interface: `BuildContext`
Associate specified `key` with specified `value` in the build context. Primary (and the only) purpose of this method is to allow preservation of state needed for proper incremental behaviour between consecutive executions of the same mojo needed to. For example, maven-plugin-plugin:descriptor mojo can store collection of extracted MojoDescritpor during first invocation. Then on each consecutive execution maven-plugin-plugin:descriptor will only need to extract MojoDescriptors for changed files.

Specified by:
  `setValue` in interface `BuildContext`
See Also:
  `BuildContext.getValue(String)`

#### addError

    public void addError(File file,
                int line,
                int column,
                String message,
                Throwable cause)

Deprecated. Use addMessage with severity=SEVERITY_ERROR instead

Specified by:
  `addError` in interface `BuildContext`

#### addWarning

    public void addWarning(File file,
                  int line,
                  int column,
                  String message,
                  Throwable cause)

Deprecated. Use addMessage with severity=SEVERITY_WARNING instead

Specified by:
  `addWarning` in interface `BuildContext`

#### addMessage

    public void addMessage(File file,
                  int line,
                  int column,
                  String message,
                  int severity,
                  Throwable cause)

Description copied from interface: `BuildContext`
Adds a message to the build context. The message is associated with a file and a location inside that file.

Specified by:
  `addMessage` in interface `BuildContext`
Parameters:
  `file` - The file or folder with which the message is associated. Should not be null and it is recommended to be an absolute path.
  `line` - The line number inside the file. Use 1 (not 0) for the first line. Use 0 for unknown/unspecified.
  `column` - The column number inside the file. Use 1 (not 0) for the first column. Use 0 for unknown/unspecified.
  `severity` - The severity of the message: SEVERITY_WARNING or SEVERITY_ERROR.
  `cause` - A Throwable object associated with the message. Can be null.

#### removeMessages

    public void removeMessages(File file)

Description copied from interface: `BuildContext`
Removes all messages associated with a file or folder during a previous build. It does not affect the messages added during the current build.

Specified by:
  `removeMessages` in interface `BuildContext`

#### isUptodate

    public boolean isUptodate(File target,
                     File source)

Description copied from interface: `BuildContext`
Returns true, if the target file exists and is uptodate compared to the source file. More specifically, this method returns true when both target and source files exist, do not have changes since last incremental build and the target file was last modified later than the source file. Returns false in all other cases.

Specified by:
  `isUptodate` in interface `BuildContext`